/*
Copyright (c) 2014 Şükrü Çınar.

All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright notice,
   this list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

void graymap_init(int red_shift,int green_shift, int blue_shift);
void graymap_draw(uint32_t *dst, uint32_t dstW, uint32_t dstH,
               int dstX, int dstY,
               uint8_t  *src, uint32_t srcW, uint32_t srcH,
               int srcX, int srcY,
               uint32_t fg, uint32_t bg,
               int W, int H);
void blend_alpha_image(uint32_t *dst,  int dstW, int dstH,
                                       int dstX, int dstY,
                       uint32_t *src,  int srcW, int srcH,
                                       int srcX, int srcY,
                       int W, int H, uint32_t bg);
void copy_area(uint32_t *dst,  int dstW, int dstH,
                               int dstX, int dstY,
               uint32_t *src,  int srcW, int srcH,
                               int srcX, int srcY,
                       int W, int H);
uint32_t server_color(uint32_t rgb);
void fill_rect(uint32_t *dst, uint32_t dstW, uint32_t dstH,
                              int x, int y, int w, int h,uint32_t color);
void xor_rect(uint32_t *dst, uint32_t dstW, uint32_t dstH,
                              int x, int y, int w, int h,uint32_t color);
void draw_rect(uint32_t *dst, uint32_t dstW, uint32_t dstH,
                              int x, int y, int w, int h,uint32_t color);
void draw_vline(uint32_t *dst, uint32_t dstW, uint32_t dstH,
                              int x, int y1, int y2, uint32_t color);
void draw_hline(uint32_t *dst, uint32_t dstW, uint32_t dstH,
                              int x1, int x2, int y, uint32_t color);
