/*
Copyright (c) 2014 Şükrü Çınar.

All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright notice,
   this list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
#include <stdint.h>
#include <string.h>
#include <stdlib.h>
#include "pngio.h"
#include "resize_image.h"

int load_icon(char *file_name, int w,int h, 
              unsigned int *Rw, unsigned int *Rh, unsigned int **Rd)
{
  unsigned int Kw,Kh,*Kd;
  char *e;
  *Rw= 0; *Rh=0; *Rd= NULL;
  if (file_name[0]==':') return load_builtin_icon(file_name, Rw, Rh, Rd);

  e= read_png_image(file_name, &Kh, &Kw, &Kd);
  if (e) { free(e); return 1; }
  if (Kw>w || Kh>h)
  {
    if (!resize_image_argb(Kd, Kw, Kh, w,h, Rd, Rw, Rh))
       { free(Kd); return 0; }
  }
  *Rw= Kw; *Rh= Kh; *Rd= Kd;
  return 0;
}

