/*
Copyright (c) 2014 Şükrü Çınar.

All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright notice,
   this list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/


typedef struct litem  list_item_t;
typedef struct xlist  list_t;

list_item_t *list_item_new(uint32_t *idata, uint32_t iw, uint32_t ih,
                           const char *txt, void *ptr);
void list_item_free(list_item_t *li);

void *list_item_data(list_item_t *li);

   /* The click function has the following prototype:
         void click(void *, list_t *list, list_item_t *item);
      I didn't put it here to avoid stupid casts. */
list_t *list_new(Window parent, int x,int y, int w,int h,
                 void *item_click_func, 
                 void *item_dclick_func, 
                 void *arg);

void list_free(list_t *L);

void list_item_select(list_t *L, list_item_t *li,int sel);

void list_prepend(list_t *L, list_item_t *li);
void list_append(list_t *L, list_item_t *li);
void list_insert_after(list_t *L, list_item_t *anchor, list_item_t *newitem);
void list_insert_before(list_t *L, list_item_t *anchor, list_item_t *newitem);
void list_remove(list_t *L, list_item_t *item);
void list_clear(list_t *L);
list_item_t *list_find_item(list_t *L, void *ptr);


