/*
Copyright (c) 2014 Şükrü Çınar.

All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright notice,
   this list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
#ifndef menu_h_included_rpoilxks
#define menu_h_included_rpoilxks

typedef struct xmenu menu_t;


menu_t *menu_start();
void menu_add_item(menu_t *M, int icon_width, int icon_height,
                              uint32_t *icon, char *text, int action);
void menu_add_sub(menu_t *M, int icon_width, int icon_height,
                             uint32_t *icon, char *text, menu_t *sub);
void menu_add_sep(menu_t *M);
void menu_end(menu_t *M);
void menu_init(cfg_menu_style_t *cfg);
void menu_display_top(menu_t *M, int bot, int left,
                      Window *Rwindow, unsigned int *Revent);
int menu_get_selected(menu_t *M);
void menu_free(menu_t *M);
int menu_is_released(menu_t *M);
void menu_release(menu_t *M);
#endif
